/*
    Copyright (C) 1998-99 Paul Barton-Davis 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: stl_delete.h,v 1.3 1999/11/08 08:17:48 stef Exp $
*/

#ifndef __libmisc_stl_delete_h__
#define __libmisc_stl_delete_h__

/* To actually use any of these deletion functions, you need to
   first include the revelant container type header.
*/

using namespace std;

#ifdef __SGI_STL_VECTOR
template<class T> void vector_delete (vector<T *> *vec) 
{
	vector<T *>::iterator i;
	
	for (i = vec->begin(); i != vec->end(); i++) {
		delete *i;
	}
	vec->clear ();
}
#endif // __SGI_STL_VECTOR

#ifdef __SGI_STL_MAP
template<class K, class T> void map_delete (map<K, T *> *m) 
{
	map<K, T *>::iterator i;

	for (i = m->begin(); i != m->end(); i++) {
		delete (*i).second;
	}
	m->clear ();
}
#endif // __SGI_STL_MAP

#ifdef __SGI_STL_LIST
template<class T> void list_delete (list<T *> *l) 
{
	list<T *>::iterator i;

	for (i = l->begin(); i != l->end(); i++) {
		delete (*i);
	}

	l->clear ();
}
#endif // __SGI_STL_LIST

#ifdef __SGI_STL_SLIST
template<class T> void slist_delete (slist<T *> *l) 
{
	slist<T *>::iterator i;

	for (i = l->begin(); i != l->end(); i++) {
		delete (*i);
	}

	l->clear ();
}
#endif // __SGI_STL_SLIST

#ifdef __SGI_STL_SET
template<class T> void set_delete (set<T *> *sset) 
{
	set<T *>::iterator i;
	
	for (i = sset->begin(); i != sset->end(); i++) {
		delete *i;
	}
	sset->erase (sset->begin(), sset->end());
}
#endif // __SGI_STL_SET

#endif // __libmisc_stl_delete_h__


